procedure nic;
begin
 asm
  nop
 end;
end;

procedure initstd;
begin
          @clearscr:=@clearscrSTD;
          @fillscreen:=@fillscreenSTD;
          @putpixel:=@nic;
          @getpixel:=@nic;
          @notpixel:=@notpixelSTD;
          @rectangle:=@rectangleSTD;
          @frame:=@frameSTD;
          @bar:=@barSTD;
          @vline:=@vlineSTD;
          @hline:=@hlineSTD;
          @circle:=@circleSTD;
          @line:=@lineSTD;
          @putpicture:=@putpictureSTD;
end;
procedure clearscrSTD;
var i,l:integer;
begin
 for i:=0 to maxx do for l:=0 to maxy do putpixel(i,l,0);
end;

procedure fillscreenSTD(b:byte);
var i,l:integer;
begin
 for i:=0 to maxx do for l:=0 to maxy do putpixel(i,l,b);
end;

procedure notpixelSTD(x,y:integer);
begin
 putpixel(x,y,not getpixel(x,y));
end;

procedure barSTD(x,y,x1,y1:integer;b:byte);
var i,w:integer;
begin
 w:=x1-x;
 for i:=y to y1-1 do
 begin
  hline(x,i,w,b);
 end;
end;
procedure rectangleSTD(x,y,x1,y1:integer;b:byte);
var i,w:integer;
begin
 w:=x1-x;
 hline(x,y,w,b);
 vline(x,y+1,y1-y-2,b);
 vline(x1,y+1,y1-y-2,b);
 hline(x,y1,w,b);
end;
procedure frameSTD(x,y,x1,y1:integer;b,b1,b2,b3:byte);
var i,w:integer;
begin
 w:=x1-x;
 hline(x,y,w,b);
 vline(x,y+1,y1-y-2,b3);
 vline(x1,y+1,y1-y-2,b1);
 hline(x,y1,w,b2);
end;
procedure vlineSTD(x,y,l:integer;b:byte);
var i:integer;
begin
 for i:=y to y+l-1 do putpixel(x,i,b);
end;
procedure hlineSTD(x,y,l:integer;b:byte);
var i:integer;
begin
 for i:=x to x+l-1 do putpixel(i,y,b);
end;
procedure circleSTD(x,y,r:integer;b:byte);
var x1,y1:integer;
    a : real;
begin
 a:=0;
 repeat
  y1:=round(-1*(r*sin(a)))+y;
  x1:=round(r*cos(a))+x;
  putpixel(x1,y1,b);
  a:=a+0.25;
 until a=360.25;
end;
procedure lineSTD(x,y,x2,y2:integer;b:Byte);
var
 d,dx,dy,ai,bi,xi,yi : integer;
begin
 if x < x2 then begin xi := 1; dx := x2-x; end
 else begin xi := -1; dx := x-x2; end;
 if y < y2 then begin yi := 1; dy := y2-y; end
 else begin yi := -1; dy := y-y2; end;
 if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,b);
 if dx > dy then begin
  ai := (dy-dx)*2; bi := dy*2; d := bi-dx;
  repeat
   if d >= 0 then begin inc(y,yi); inc(d,ai); end else inc(d,bi);
   inc(x,xi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,b);
  until x = x2;
 end
 else begin
  ai := (dx-dy)*2; bi := dx*2; d := bi-dy;
  repeat
   if d >= 0 then begin inc(x,xi); inc(d,ai); end else inc(d,bi);
   inc(y,yi); if (x>=0)and(x<=639)and(y>=0)and(y<=479)then putpixel(x,y,b);
  until y = y2;
 end;
end;

procedure putpictureSTD(vx,vy:word;p:pointer);
var i,l,x,y:integer;se:word;off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 x:=memw[se:off];
 y:=memw[se:off+2];
 for l:=0 to y-1 do
 for i:=0 to x-1 do
 begin
  if mem[se:off+4+(l*x)+i]<>0 then
  putpixel(i+vx,l+vy,mem[se:off+(l*x)+4+i]);
 end;
end;
