unit txtobj;
interface
type string2=string[2];

const startwindowwidth:integer=8;
const btNothing=0;
      btYes       = $0001;
      btNo        = $0002;
      btContinue  = $0004;
      btAbort     = $0008;
      btAll       = $0010;
      btNever     = $0020;
      btOk        = $0040;
      btCustom    = $0080;
      btIgnore    = $0100;
      btRetro     = $0200;
      btEnd       = $0400;

      alLeft=1;
      alRight=2;
      alCenter=3;
const icOK=1;icCancel=2;icNext=3;icBroswe=4;

type tbuttontxt=object
      x,y,x1,y1:word;
      active,down:boolean;
      caption:string;
      event:word;
      picture:word;
      procedure draw;
      procedure oznac;
      procedure odznac;
      function  kolize(xx,yy:word):boolean;
      procedure new(px,py,px1,py1:word;pcaption:string);
     end;
type twindowtxt=object
      x,y,x1,y1:word;
      b:array[1..10] of tbuttontxt;
      btns:array[1..10] of word;
      akb,bcount:integer;
      caption:string;
      procedure draw;
      procedure new(px,py,px1,py1:word;pcaption:string);
      procedure run(xx:word;align:word);
      function  checkevent:word;
      function  checkpevent(mx,my:word;t1:boolean;ch:string2):word;
      procedure destroy;
     end;

type tedittxt=object
      x,y,x1,y1:word;
      scrx,scry:byte;
      zobrc,zobrmax,maxc,akc,ozns:word;
      active,down:boolean;
      caption:string;
      event:word;
      procedure draw;
      procedure new(px,py,px1:word;pcaption:string);
      function  checkevent(mx,my:word;t1:boolean;ch:string2):boolean;
     end;

procedure InstallFnt;
Procedure setFont(tfont: pointer);
procedure cursor(state:boolean);
procedure writexy(x,y:integer;s:string);
procedure writexyc(x,y:integer;s:string;c:byte);

var schranka:string;
implementation
uses dos, vga, crt, myska, man_key;

procedure InstallFnt;external;
{$L install.obj}

Procedure setFont(tfont: pointer);
var  R: Registers;
Begin;
 r.ax:=$1100;
 r.bh:=16;
 r.bl:=0;
 r.cx:=256;
 r.dx:=0;
 r.es:=Seg(Tfont^);
 r.bp:=Ofs(Tfont^);
 intr($10,r);
End;

procedure cursor(state:boolean);
var reg:registers;
const sstart:byte=12;
      send:byte=14;
begin
 with reg do
        case state of
              true: begin AH:=1;CH:=SStart;CL:=SEnd end;
              false:begin AH:=1;CH:=32;    CL:=0    end;
        end;
 intr($10,reg);
end;

procedure writexy(x,y:integer;s:string);
begin
 gotoxy(x,y);write(s);
end;
procedure writexyc(x,y:integer;s:string;c:byte);
begin
 textcolor(c);gotoxy(x,y);write(s);
end;

procedure shadow(x,y:word);
var r:registers;
begin
 gotoxy(x,y);
 with r do
 begin
  r.ah:=$8;
  r.bh:=0;
  intr($10,r);
  r.ah:=$9;
  r.cx:=1;
  r.bl:=8;
  intr($10,r);
 end;
end;

procedure tbuttontxt.draw;
begin
 textcolor(7);
 gotoxy(x,y);
 textbackground(2);write(#5);
 textbackground(2);textcolor(2);
 case picture of
  icOK:begin textcolor(10);write(#21#32);end;
  icCancel:begin textcolor(4);write(#14#32);end;
  icNext:begin textcolor(1);write(#15#32);end;
  icBroswe:begin textcolor(14);write(#2#32);end;
  else write('');
 end;
 if down then textcolor(14) else
 if active then textcolor(15) else textcolor(0);write(caption);
 textcolor(2);textbackground(7);write('');
 write(#29);
end;
procedure tbuttontxt.new(px,py,px1,py1:word;pcaption:string);
var i:integer;
begin
 x:=px;y:=py;
 x1:=px1;y1:=py1;
 caption:=pcaption;
 if length(caption)>startwindowwidth then delete(caption,startwindowwidth,length(caption)-startwindowwidth);
 if length(caption)<startwindowwidth then
  for i:=length(caption) to startwindowwidth do caption:=caption+' ';
 down:=false;
 active:=false;
 draw;
end;

procedure tbuttontxt.oznac;
begin
 active:=true;
 draw;
end;

procedure tbuttontxt.odznac;
begin
 active:=false;
 draw;
end;

function  tbuttontxt.kolize(xx,yy:word):boolean;
begin
 if inarea(xx,yy,x,y,x1,y1) then kolize:=true else kolize:=false;
end;

procedure twindowtxt.draw;
var i,l:integer;
begin
 textcolor(15);
 gotoxy(x,y);write('');for i:=1 to x1-x-1 do write('');write('');

 for i:=1 to y1-y-1 do begin textcolor(15);gotoxy(x,y+i);write('');textcolor(0);
                             gotoxy(x1,y+i);write('');end;
 gotoxy(x,y1);write('');for i:=1 to x1-x-1 do write('');write('');
 for i:=1 to x1-x-1 do begin for l:=1 to y1-y-1 do begin
 gotoxy(x+i,y+l);write(' ');end;end;
 textcolor(15);
 gotoxy(x+2,y);write('');textbackground(3);
 textcolor(15);write(caption);textcolor(1);
 textcolor(8);
 textbackground(7);write('');
 for i:=x+1 to x1+2 do shadow(i,y1+1);
 for i:=y+1 to y1 do shadow(x1+1,i);
 for i:=y+1 to y1 do shadow(x1+2,i);
end;

procedure twindowtxt.destroy;
begin
end;

procedure  twindowtxt.run(xx:word;align:word);
var btcount:word;i,l:integer;
    t1,t2,t3:boolean;mx,my:word;
procedure createbutton(x,y,xxx,idx:word);
begin
 b[idx].x:=x;b[idx].y:=y;b[idx].x1:=x+startwindowwidth;b[idx].y1:=y;
 b[idx].event:=xxx;b[idx].down:=false;
 case xxx of
      btYes:b[idx].caption:='Ano';
      btOk:b[idx].caption:='OK';
      btNo:b[idx].caption:='Ne';
      btContinue:b[idx].caption:='Pokraovat';
      btAbort:b[idx].caption:='Zruit';
      btAll:b[idx].caption:='Vechny';
      btNever:b[idx].caption:='dn';

      btIgnore:b[idx].caption:='Ignorovat';
      btRetro:b[idx].caption:='Opakovat';
      btEnd:b[idx].caption:='Konec';

 end;
 b[idx].draw;
end;
var sg,og:word;
begin
 nic;
 btcount:=0;
 if (xx and btYes)=btYes then begin btcount:=btcount+1;btns[btcount]:=btYes;b[btcount].picture:=icOK;end;
 if (xx and btOk)=btOk then begin btcount:=btcount+1;btns[btcount]:=btOk;b[btcount].picture:=icOK;end;
 if (xx and btNo)=btNo then begin btcount:=btcount+1;btns[btcount]:=btNo;;b[btcount].picture:=icCancel;end;
 if (xx and btAll)=btAll then begin btcount:=btcount+1;btns[btcount]:=btAll;b[btcount].picture:=icOK;end;
 if (xx and btNever)=btNever then begin btcount:=btcount+1;btns[btcount]:=btNever;b[btcount].picture:=icCancel;end;
 if (xx and btContinue)=btContinue then begin btcount:=btcount+1;btns[btcount]:=btContinue;b[btcount].picture:=icNext;end;
 if (xx and btAbort)=btAbort then begin btcount:=btcount+1;btns[btcount]:=btAbort;b[btcount].picture:=icCancel;end;
 if (xx and btRetro)=btRetro then begin btcount:=btcount+1;btns[btcount]:=btRetro;end;
 if (xx and btIgnore)=btIgnore then begin btcount:=btcount+1;btns[btcount]:=btIgnore;b[btcount].picture:=icNext;end;
 if (xx and btEnd)=btEnd then begin btcount:=btcount+1;btns[btcount]:=btEnd;b[btcount].picture:=icCancel;end;
 if (xx and btCustom)=btCustom then begin btcount:=btcount+1;end;

 for i:=1 to btcount do
 case align of
  alLeft:createbutton(x+(i-1)*(startwindowwidth+7)+1,y1-1,btns[i],i);
  alRight:createbutton(x1-(btcount-i+1)*(startwindowwidth+7)-4,y1-1,btns[i],i);
  alCenter:createbutton(x+(i-1)*(startwindowwidth+7)+((x1-x)-(btcount*(startwindowwidth+7))) div 2,y1-1,btns[i],i);
 end;
 b[1].oznac;akb:=1;
 bcount:=btcount;
end;

function twindowtxt.checkevent:word;
var btcount:word;i,l:integer;
    t1,t2,t3:boolean;mx,my:word;
    ch:char;
begin
  btcount:=bcount;
  mousestatus(mx,my,t1,t2,t3);
  mx:=mx div 8+1;my:=my div 8+1;
  checkevent:=btNothing;
  if t1 then for i:=1 to btcount do if b[i].kolize(mx,my) then
  begin
   for l:=1 to btcount do b[l].odznac;
   b[i].down:=true;
   b[i].oznac;
   b[i].draw;
   repeat
    mousestatus(mx,my,t1,t2,t3);
    mx:=mx div 8+1;my:=my div 8+1;
   until not t1;
   if b[i].kolize(mx,my) then
   begin
    checkevent:=b[i].event;
   end;
   b[i].down:=false;
   akb:=i;
   for l:=1 to btcount do b[l].draw;
  end;
  ch:=#255;
  if keypressed then ch:=readkey;
  if ch=k_Tab then    if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin b[1].odznac;akb:=btcount;b[akb].oznac;end;
  if ch=#0 then
  begin
   ch:=readkey;
   if ch=k_Right then if akb<btcount then begin akb:=akb+1;b[akb-1].odznac;b[akb].oznac;end
                                     else begin akb:=1;b[akb].oznac;b[btcount].odznac;end;
   if ch=k_Left then  if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin akb:=btcount;b[1].odznac;b[akb].oznac;end;
  end;
  if ch=k_Esc then begin checkevent:=btAbort;end;
  if ch=k_Enter then begin checkevent:=b[akb].event;end;
end;
function twindowtxt.checkpevent(mx,my:word;t1:boolean;ch:string2):word;
var btcount:word;i,l:integer;
    t2,t3:boolean;
begin
  btcount:=bcount;
  mx:=mx div 8+1;my:=my div 8+1;
  checkpevent:=btNothing;
  if t1 then for i:=1 to btcount do if b[i].kolize(mx,my) then
  begin
   for l:=1 to btcount do b[l].odznac;
   b[i].down:=true;
   b[i].oznac;
   b[i].draw;
   repeat
    mousestatus(mx,my,t1,t2,t3);
    mx:=mx div 8+1;my:=my div 8+1;
   until not t1;
   if b[i].kolize(mx,my) then
   begin
    checkpevent:=b[i].event;
   end;
   b[i].down:=false;
   akb:=i;
   for l:=1 to btcount do b[l].draw;
  end;
  if ch[1]=k_Tab then    if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin b[1].odznac;akb:=btcount;b[akb].oznac;end;
  if ch[1]=#0 then
  begin
   if ch[2]=k_Right then if akb<btcount then begin akb:=akb+1;b[akb-1].odznac;b[akb].oznac;end
                                     else begin akb:=1;b[akb].oznac;b[btcount].odznac;end;
   if ch[2]=k_Left then  if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin akb:=btcount;b[1].odznac;b[akb].oznac;end;
  end;
  if ch[1]=k_Esc then begin checkpevent:=btAbort;end;
  if ch[1]=k_Enter then begin checkpevent:=b[akb].event;end;
end;
procedure twindowtxt.new(px,py,px1,py1:word;pcaption:string);
begin
 x:=px;y:=py;
 x1:=px1;y1:=py1;
 caption:=pcaption;
 y:=y+1;y1:=y1+1;
 draw;
end;



procedure tedittxt.draw;
var i,l,m:integer;s:string;
begin
 s:='';for i:=x to x1 do s:=s+' ';
 cursor(false);schovej_mysku;
 l:=textattr;textbackground(3);writexyc(x,y,s,0);

 i:=akc-zobrc;
 l:=ozns-zobrc-1;
 if l<0 then l:=0;
 if l>zobrmax-1 then l:=zobrmax-1;
{ if akc<>zobrc then
   if l>i then gotoxy(x+i*8,y+1,x+l*8,y+15,1)
          else bar(x+l*8,y+1,x+i*8,y+15,1);}
 m:=zobrmax;
 if m+zobrc-2>length(caption) then m:=length(caption)-zobrc;
 writexy(x,y,copy(caption,zobrc,m+1));textattr:=l;
 gotoxy(x+(akc-zobrc),y);ukaz_mysku;cursor(true);
 scrx:=x+(akc-zobrc);scry:=y;
end;
procedure tedittxt.new(px,py,px1:word;pcaption:string);
begin
 x:=px;y:=py;
 x1:=px1;y1:=y+16;
 caption:=pcaption;
 akc:=length(caption)+1;
 ozns:=akc+1;
 maxc:=255;
 zobrc:=1;
 zobrmax:=(x1-x);
 draw;
end;

function  tedittxt.checkevent(mx,my:word;t1:boolean;ch:string2):boolean;
begin
 if (ch[1]<>#0) and (ord(ch[1])>30) and (length(caption)<maxc) then
 begin
  akc:=akc-1;
  caption:=copy(caption,1,akc)+ch[1]+copy(caption,akc+1,length(caption)-akc);
  akc:=akc+2;
  if akc+1>zobrc+zobrmax then zobrc:=zobrc+1;
{  hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
  ozns:=akc+1;
  draw;
 end;
 if (ch[1]=k_backspace) and (akc>0) then
 begin
  delete(caption,akc-1,1);
  akc:=akc-1;
  if akc<zobrc then zobrc:=akc;
{  hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
  ozns:=akc+1;
  draw;
 end;
 if length(ch)=2 then
 case ch[2] of
  k_Left:if akc>1 then
     begin
      akc:=akc-1;{hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
      if akc<zobrc then zobrc:=akc;
      if not SHIFTPRESSED then ozns:=akc+1;
      draw;
     end;
  k_Right:if akc<length(caption)+1 then
     begin
      akc:=akc+1;{hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
      if akc+1>zobrc+zobrmax then zobrc:=zobrc+1;
      if not SHIFTPRESSED then ozns:=akc+1;
      draw;
     end;
  k_End:begin akc:=length(caption)+1;
         {hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
         if not SHIFTPRESSED then ozns:=akc+1;
         if akc>zobrc+zobrmax then zobrc:=akc-zobrc-zobrmax+2 else zobrc:=1;
         ozns:=akc+1;{*}
         draw;end;
  k_Home:begin akc:=1;
          if not SHIFTPRESSED then ozns:=akc+1;
          {hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}zobrc:=1;
          ozns:=akc+1;{*}
          draw;
         end;
  k_del: if akc<length(caption) then
  begin
   delete(caption,akc,1);
{   hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;}
   draw;
  end;
 end;
end;

end.